#include<18f4550.h>
#fuses HSPLL, NOWDT, NOPROTECT, NOLVP, NODEBUG, USBDIV, PLL2, CPUDIV1, VREGEN
#use delay (clock=48M)
#include <MLCD.c>
#include "MMA8452Q.c"
#use  standard_io(e)
#use  standard_io(c)

void main(){
//Definicin de variables
   signed long int ejex = 0, ejey = 0, ejez = 0;
   int   lapo = 0, bafro = 0;
   int   pulso = 0;
   int   pantalla = 0;

   set_tris_c(0xFF); //Habilitamos el puerto C como entrada
   set_tris_e(0x00); //Habilitamos el puerto E como salida 
   output_e(0x07);   //Apagamos el led RGB
   lcd_init(); //Inicializamos la LCD
   MMA8452_init(IPOL_HIGH|INT1_DATAREADY|INT2_LNDPRT|INT2_PULSE); //Inicializamos el sensor
   MMA8452_enPortLand();   // Habilitamos la deteccin de orientacin
   MMA8452_enTapDet(SINGLE_DOUBLE);    //Habilitamos la deteccin de pulsos
   
   while(TRUE){
//Deteccin de pulsador para modificar la informacin de la pantalla
      if (input_state(PIN_C0)){     // Se presion el pulsador?
         delay_ms(200);
         pantalla++;                // Aumentamos el valor de pantalla
         if (pantalla >= 2){        // Si pantalla es mayor o igual a 2
            pantalla = 0;           // la reiniciamos a 0
         }
      }

//LECTURA DE LOS 3 EJES
      if (input_state(INT1_PIN)){   // Hubo interrupcin del PIN 1 del sensor?
         ejex = MMA8452_x_read();   // Leemos el eje X
         ejey = MMA8452_y_read();   // Leemos el eje Y
         ejez = MMA8452_z_read();   // Leemos el eje Z
      }

// TAP DETECTION
      if (input_state(INT2_PIN)){   // Hubo interrupcin del PIN 2 del sensor?
      pulso = MMA8452_getTap();     // Verificamos si fue sencillo o doble
         if (pulso == MMA8452_DOUBLE_PULSE){           // Si fue doble
            output_toggle(PIN_E2);  // Encendemos el led AZUL
         }  
         else if (pulso == MMA8452_SINGLE_PULSE){      // Si fue sencillo
            output_toggle(PIN_E1);  // Encendemos el led ROJO 
         }      
      }
// LECTURA DE LA ORIENTACION      
      if (input_state(INT2_PIN)){   // Hubo interrupcin del PIN 2 del sensor?
         lapo = MMA8452_LaPo();     // Portland o Landscape?
         bafro = MMA8452_BaFro();   // Back o Front?
      }
      
// MOSTRAMOS LA INFORMACIN EN LA LCD
      if (pantalla == 0){
         printf(lcd_putc, "\fX=%4ld", ejex);
         lcd_gotoxy(1,2);
         printf(lcd_putc, "Y=%4ld Z=%4ld", ejey,ejez);
         delay_ms(200);
      }
      else{  
         if (lapo == MMA8452_PORTRAIT_UP){
            printf(lcd_putc, "\fPortrait Up");
         }
         else if (lapo == MMA8452_PORTRAIT_DOWN){
            printf(lcd_putc, "\fPortrait Down");
         }
         else if (lapo == MMA8452_LANDSCAPE_RIGHT){
            printf(lcd_putc, "\fLandscape Right");
         }
         else{
            printf(lcd_putc, "\fLandscape Left");
         }
         if (bafro == MMA8452_FRONT_FACE){
            printf(lcd_putc, "\nFront");
         }
         else{
            printf(lcd_putc, "\nBack");
         }
         delay_ms(200);
      }
   }
}

